## mender-client 5.0.0

=== CMakeLists.txt ===
# We require CMake 3.14 for FetchContent_MakeAvailable, which is used
# to download BOOST when the user selects option MENDER_DOWNLOAD_BOOST.
# Without this option, it works with 3.13 and possibly older versions.
#
cmake_minimum_required(VERSION 3.14)

project(mender)

add_subdirectory(support)
add_subdirectory(Documentation)

if(NOT "${MENDER_NO_BUILD}" STREQUAL "1")
  include(main.cmake)
endif()

=== Documentation/CMakeLists.txt ===
include(GNUInstallDirs)

set(DBUS_INTERFACE_FILES
  io.mender.Authentication1.xml
)

install(FILES ${DBUS_INTERFACE_FILES}
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dbus-1/interfaces
  COMPONENT dbus-interface-files
)
add_custom_target(install-dbus-interface-files
  COMMAND ${CMAKE_COMMAND} --install ${CMAKE_BINARY_DIR} --component dbus-interface-files
)
add_custom_target(uninstall-dbus-interface-files
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component dbus-interface-files -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

=== src/CMakeLists.txt ===
execute_process(
  COMMAND sh -c "git describe --tags --dirty --exact-match 2>/dev/null || git rev-parse --short HEAD"
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  OUTPUT_VARIABLE MENDER_VERSION
  OUTPUT_STRIP_TRAILING_WHITESPACE
  ERROR_VARIABLE GIT_CMD_ERROR
)
if(NOT "${GIT_CMD_ERROR}" STREQUAL "")
  message(FATAL_ERROR "Git command failed:\n" ${GIT_CMD_ERROR})
endif()

configure_file(mender-version.h.in mender-version.h)

set(MENDER_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(MENDER_BINARY_SRC_DIR ${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(common)
add_subdirectory(api)
add_subdirectory(client_shared)
add_subdirectory(mender-update)
add_subdirectory(mender-auth)
add_subdirectory(artifact)

=== support/CMakeLists.txt ===
set(SYSTEMD_UNIT_DIR /lib/systemd/system CACHE STRING "Directory where systemd unit files are installed")

include(GNUInstallDirs)

option(MENDER_DATA_DIR_SYSTEMD_UNIT "Install the mender-data-dir.service file" OFF)

set(DBUS_POLICY_FILES
  dbus/io.mender.AuthenticationManager.conf
)
set(DOCS_EXAMPLES demo.crt)
set(IDENTITYSCRIPTS mender-device-identity)
set(INVENTORYSCRIPTS
  mender-inventory-bootloader-integration
  mender-inventory-hostinfo
  mender-inventory-intervals
  mender-inventory-network
  mender-inventory-os
  mender-inventory-provides
  mender-inventory-rootfs-type
  mender-inventory-update-modules
)
set(INVENTORY_NETWORKSCRIPTS mender-inventory-geo
)
set (ROOTFS_IMAGE
  modules/rootfs-image
)
set(MODULES
  modules/directory
  modules/single-file
  ${ROOTFS_IMAGE}
)
set(MODULES_ARTIFACT_GENERATORS
  modules-artifact-gen/directory-artifact-gen
  modules-artifact-gen/single-file-artifact-gen
)
set(SYSTEMD_UNITS
  mender-updated.service
  mender-authd.service
)

if(MENDER_DATA_DIR_SYSTEMD_UNIT)
  list(APPEND SYSTEMD_UNITS mender-data-dir.service)
endif()

install(PROGRAMS ${INVENTORYSCRIPTS}
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/mender/inventory
  COMPONENT inventory-scripts
)
add_custom_target(install-inventory-scripts
  COMMAND ${CMAKE_COMMAND} --install ${CMAKE_BINARY_DIR} --component inventory-scripts
)
add_custom_target(uninstall-inventory-scripts
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component inventory-scripts -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

install(PROGRAMS ${INVENTORY_NETWORKSCRIPTS}
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/mender/inventory
  COMPONENT inventory-network-scripts
  # Disabled by default to avoid API throttling.
  EXCLUDE_FROM_ALL
)
add_custom_target(install-inventory-network-scripts
  COMMAND ${CMAKE_COMMAND} --install ${CMAKE_BINARY_DIR} --component inventory-network-scripts
)
add_custom_target(uninstall-inventory-network-scripts
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component inventory-network-scripts -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

install(PROGRAMS ${IDENTITYSCRIPTS}
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/mender/identity
  COMPONENT identity-scripts
)
add_custom_target(install-identity-scripts
  COMMAND ${CMAKE_COMMAND} --install ${CMAKE_BINARY_DIR} --component identity-scripts
)
add_custom_target(uninstall-identity-scripts
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component identity-scripts -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

install(FILES ${DBUS_POLICY_FILES}
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dbus-1/system.d
  COMPONENT dbus-policy-files
)
add_custom_target(install-dbus-policy-files
  COMMAND ${CMAKE_COMMAND} --install ${CMAKE_BINARY_DIR} --component dbus-policy-files
)
add_custom_target(uninstall-dbus-policy-files
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component dbus-policy-files -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

install(PROGRAMS ${MODULES}
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/mender/modules/v3
  COMPONENT modules
)
add_custom_target(install-modules
  COMMAND ${CMAKE_COMMAND} --install ${CMAKE_BINARY_DIR} --component modules
)
add_custom_target(uninstall-modules
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component modules -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

install(PROGRAMS ${MODULES_ARTIFACT_GENERATORS}
  DESTINATION bin
  COMPONENT modules-gen
  # Disabled by default since devices don't typically need them.
  EXCLUDE_FROM_ALL
)
add_custom_target(install-modules-gen
  COMMAND ${CMAKE_COMMAND} --install ${CMAKE_BINARY_DIR} --component modules-gen
)
add_custom_target(uninstall-modules-gen
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component modules-gen -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

install(FILES ${SYSTEMD_UNITS}
  DESTINATION ${SYSTEMD_UNIT_DIR}
  COMPONENT systemd
)
add_custom_target(install-systemd
  COMMAND ${CMAKE_COMMAND} --install ${CMAKE_BINARY_DIR} --component systemd
)
add_custom_target(uninstall-systemd
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component systemd -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

# Not using CMAKE_INSTALL_DOCDIR as it will default to .../doc/mender/
install(FILES ${DOCS_EXAMPLES}
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/doc/mender-auth/examples
  COMPONENT examples
)
add_custom_target(install-examples
  COMMAND ${CMAKE_COMMAND} --install ${CMAKE_BINARY_DIR} --component examples
)
add_custom_target(uninstall-examples
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component examples -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

install(PROGRAMS ${ROOTFS_IMAGE}
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/mender/modules/v3
  COMPONENT rootfs-image-module
)
add_custom_target(install-rootfs-image-module
  COMMAND ${CMAKE_COMMAND} --install ${CMAKE_BINARY_DIR} --component rootfs-image-module
)
add_custom_target(uninstall-rootfs-image-module
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component rootfs-image-module -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

=== tests/CMakeLists.txt ===
enable_testing()
set(GTEST_VERSION 1.12.1)
set(MENDER_SRC_DIR ${CMAKE_SOURCE_DIR}/src)
set(MENDER_TEST_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

option(MENDER_DOWNLOAD_GTEST "Download google test if it is not found (Default: ON)" ON)
if (MENDER_DOWNLOAD_GTEST)
  ### BEGIN taken from https://google.github.io/googletest/quickstart-cmake.html
  include(FetchContent)
  FetchContent_Declare(
    googletest
    URL https://github.com/google/googletest/archive/refs/tags/release-${GTEST_VERSION}.zip
  )

  # For Windows: Prevent overriding the parent project's compiler/linker settings
  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
  ### END

  set(BUILD_GMOCK ON)
  set(INSTALL_GTEST OFF)
  FetchContent_MakeAvailable(googletest)
else()
  find_package(GTest REQUIRED)
endif()

if($CACHE{COVERAGE})
  add_custom_target(coverage_enabled COMMAND true)
else()
  add_custom_target(coverage_enabled
    COMMAND echo 'Please run `cmake -D COVERAGE=ON .` first!'
    COMMAND false
  )
endif()

add_custom_target(coverage
  DEPENDS coverage_enabled check
  COMMAND ${CMAKE_COMMAND} --build . --target coverage_no_tests
)

# This doesn't build nor run the tests. Useful if you want to manually run just one test instead of
# all tests.
add_custom_target(coverage_no_tests
  DEPENDS coverage_enabled
  COMMAND lcov --capture --quiet --directory ${CMAKE_SOURCE_DIR}
               --output-file ${CMAKE_SOURCE_DIR}/coverage.lcov
               --exclude '/usr/*'
               --exclude '*/googletest/*'
               --exclude '*_test.*'
               --exclude '*/googlemock/*'
               --exclude '*/vendor/*'
)

# CMake is not clever enough to build the tests before running them so we use
# the 'check' target below that does both.
add_custom_target(check
  COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
  DEPENDS tests
)
add_custom_target(tests
  # This target itself does nothing, but all tests are added as dependencies for it.
  COMMAND true
)

include(GoogleTest)
set(MENDER_TEST_FLAGS EXTRA_ARGS --gtest_output=xml:${CMAKE_SOURCE_DIR}/reports/)
include_directories(${CMAKE_BINARY_DIR}/src ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests/src)
add_subdirectory(src/api)
add_subdirectory(src/artifact)
add_subdirectory(src/common)
add_subdirectory(src/client_shared)
add_subdirectory(src/mender-auth)
add_subdirectory(src/mender-update)

=== src/api/CMakeLists.txt ===
project(mender-api)

add_library(api_auth STATIC auth/auth.cpp)
target_link_libraries(api_auth PUBLIC
  common_log
  common_crypto
  common_json
  common_http
  common_events
  common_io
)
if(MENDER_USE_DBUS)
  target_sources(api_auth PRIVATE auth/platform/dbus/auth.cpp)
  target_link_libraries(api_auth PUBLIC
    common_dbus
  )
elseif(MENDER_EMBED_MENDER_AUTH)
  # Will be further linked with code in mender-auth folder.
else()
  message(FATAL_ERROR "Either MENDER_USE_DBUS or MENDER_EMBED_MENDER_AUTH needs to be enabled")
endif()

add_library(api_client STATIC client.cpp)
target_link_libraries(api_client PUBLIC
  api_auth
  common_log
  common_http
  common_events
)

=== src/artifact/CMakeLists.txt ===
project(mender-artifact)

add_subdirectory(sha)
add_subdirectory(tar)
add_subdirectory(v3/scripts)

set(parser_sources
  parser.cpp
  error.cpp
  v3/version/version.cpp
  v3/manifest/manifest.cpp
  v3/header/header.cpp
  v3/header/header_info.cpp
  v3/header/type_info.cpp
  v3/header/meta_data.cpp
  v3/payload/payload.cpp
  v3/manifest_sig/manifest_sig.cpp
)

add_library(artifact_parser STATIC ${parser_sources})
target_link_libraries(artifact_parser PUBLIC
  common_json
  common_log
  common_tar
  common_error
  common_path
  sha
  common_io
  common_crypto
)
target_compile_options(common_json PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
add_library(artifact STATIC artifact.cpp)
target_link_libraries(artifact PUBLIC artifact_parser)
target_include_directories(artifact PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

=== src/client_shared/CMakeLists.txt ===
add_library(client_shared_config_parser STATIC config_parser/config_parser.cpp)
target_link_libraries(client_shared_config_parser PUBLIC common_json common_log)

add_library(client_shared_identity_parser STATIC identity_parser/identity_parser.cpp)
target_link_libraries(client_shared_identity_parser PUBLIC common_key_value_parser common_processes common_json)

add_library(client_shared_inventory_parser STATIC)
target_sources(client_shared_inventory_parser PRIVATE inventory_parser/platform/c++17/inventory_parser.cpp)
target_compile_options(client_shared_inventory_parser PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
target_link_libraries(client_shared_inventory_parser PUBLIC common_key_value_parser common_processes common_log)

add_library(client_shared_conf STATIC conf/conf.cpp conf/conf_cli_help.cpp)
target_link_libraries(client_shared_conf PUBLIC common_http common_log common_error common_path client_shared_config_parser)

=== src/common/CMakeLists.txt ===
project(mender-common)

include(CheckCXXSourceCompiles)

# TODO: proper platform detection
set(PLATFORM linux_x86)

set(MENDER_BUFSIZE 16384 CACHE STRING "Size of most internal block buffers. Can be reduced to conserve memory, but increases CPU usage.")
option(MENDER_LOG_BOOST "Use Boost as the underlying logging library provider (Default: ON)" ON)
option(MENDER_TAR_LIBARCHIVE "Use libarchive as the underlying tar library provider (Default: ON)" ON)
option(MENDER_SHA_OPENSSL "Use OpenSSL as the underlying shasum provider (Default: ON)" ON)
option(MENDER_CRYPTO_OPENSSL "Use OpenSSL as the underlying cryptography provider (Default: ON)" ON)

option(MENDER_ARTIFACT_GZIP_COMPRESSION "Enable GZIP compression support when downloading and extracting Artifacts (Default: ON)" ON)
option(MENDER_ARTIFACT_LZMA_COMPRESSION "Enable LZMA compression support when downloading and extracting Artifacts (Default: ON)" ON)
option(MENDER_ARTIFACT_ZSTD_COMPRESSION "Enable Zstd compression support when downloading and extracting Artifacts (Default: ON)" ON)
option(MENDER_USE_YAML_CPP "Use Yaml CPP as the Yaml library provider (Default: OFF)" OFF)

if (${PLATFORM} STREQUAL linux_x86)
  set(POSIX_DEFAULT ON)
else()
  set(POSIX_DEFAULT OFF)
endif()

option(MENDER_USE_DBUS "Enable DBus to communicate between processes" ${POSIX_DEFAULT})
option(MENDER_USE_ASIO_LIBDBUS "Use Boost ASIO DBus backend" ${POSIX_DEFAULT})
option(MENDER_USE_BOOST_ASIO "" ${POSIX_DEFAULT})
option(MENDER_USE_BOOST_BEAST "" ${POSIX_DEFAULT})
option(MENDER_USE_LMDB "" ${POSIX_DEFAULT})
option(MENDER_USE_NLOHMANN_JSON "" ${POSIX_DEFAULT})
option(MENDER_USE_TINY_PROC_LIB "" ${POSIX_DEFAULT})

configure_file(config.h.in config.h)

if(${MENDER_USE_TINY_PROC_LIB})
  add_subdirectory(vendor/tiny-process-library)
endif()

include(cmake/boost.cmake)

add_library(common_cpp INTERFACE)
target_compile_options(common_cpp INTERFACE
  # Make all warnings that are on into errors.
  -Werror -Wall

  # Make sure we use `override` everywhere.
  -Wsuggest-override

  # Warn about lossy number conversions, which often arise in int64_t vs size_t scenarios.
  -Wconversion

  # Don't warn about sign conversion, which have an extreme amount of false positives. This is
  # mainly because sizes are unsigned, while iterator arithmetic is signed, and they are very often
  # combined, which is perfectly fine. It's possible this may hide certain real errors, but the
  # sheer amount of false positives just isn't worth it.
  -Wno-sign-conversion

  # Miscellaneus.
  -Wpacked
  -Wpointer-arith
  -Wredundant-decls
  -Wold-style-cast
)
target_include_directories(common_cpp SYSTEM INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/vendor/expected/include)
target_include_directories(common_cpp SYSTEM INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/vendor/optional-lite/include)

add_library(common STATIC common.cpp)
target_include_directories(common PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/..)
# For the generated config.h.
target_include_directories(common PUBLIC ${CMAKE_CURRENT_BINARY_DIR}/..)
target_link_libraries(common PUBLIC common_cpp)

add_library(common_setup STATIC setup/platform/posix/setup.cpp)
target_link_libraries(common_setup PUBLIC common)

add_library(common_error STATIC
  error.cpp
  error/platform/c++11/error.cpp
)
target_link_libraries(common_error PUBLIC common)

add_library(common_io STATIC
  io/io.cpp
  io/platform/c++17/io.cpp
  io/platform/posix/io.cpp
)
target_compile_options(common_io PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
target_link_libraries(common_io PUBLIC common)

add_library(common_path STATIC)
target_sources(common_path PRIVATE
  path/path.cpp
  path/platform/c++17/path.cpp
  path/platform/posix/path.cpp
)
target_compile_options(common_path PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
target_link_libraries(common_path
  PUBLIC
  common_log
)

check_cxx_source_compiles("#include <filesystem>
  int main() { std::filesystem::path p(\"/\"); }" STD_FILESYSTEM_AVAILABLE)
if(NOT "${STD_FILESYSTEM_AVAILABLE}" STREQUAL 1)
  target_link_libraries(common_path PUBLIC ${STD_FILESYSTEM_LIB_NAME})
endif()

add_library(common_json STATIC json/json.cpp)
target_compile_options(common_json PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
if(MENDER_USE_NLOHMANN_JSON)
  target_sources(common_json PRIVATE json/platform/nlohmann/nlohmann_json.cpp)
  target_include_directories(common_json PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/vendor/json/include/)
  target_link_libraries(common_json PUBLIC common common_io common_error)
endif()

add_library(common_key_value_database STATIC
  key_value_database.cpp
)
target_compile_options(common_key_value_database PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
if(MENDER_USE_LMDB)
  target_sources(common_key_value_database PRIVATE key_value_database/platform/lmdb/lmdb.cpp)
  # Note: Use SYSTEM include style, since lmdbxx triggers some of our warnings.
  target_include_directories(common_key_value_database SYSTEM PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/vendor/lmdbxx/include)
  target_link_libraries(common_key_value_database PUBLIC
    lmdb
    common
    common_log
  )
endif()

add_library(common_events STATIC
  events/events_io.cpp
  events/platform/boost/events.cpp
  events/platform/boost/events_io.cpp
)
target_compile_options(common_events PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
target_link_libraries(common_events PUBLIC common_error common_log)
target_link_libraries(common_events PUBLIC Boost::asio)

find_package(OpenSSL REQUIRED)
if(NOT ${OpenSSL_Found})
  message(FATAL_ERROR "OpenSSL not found during build")
endif()

if ("${OPENSSL_VERSION}" VERSION_LESS 3.0.0)
  set(MENDER_CRYPTO_OPENSSL_LEGACY 1)
else()
  set(MENDER_CRYPTO_OPENSSL_LEGACY 0)
endif()

configure_file(crypto/platform/openssl/openssl_config.h.in crypto/platform/openssl/openssl_config.h)

add_library(common_http STATIC http/http.cpp http/platform/beast/http.cpp)
target_compile_options(common_http PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
target_link_libraries(common_http PUBLIC
  Boost::beast
  common
  common_crypto
  common_events
  common_error
  common_log
  OpenSSL::SSL
  OpenSSL::Crypto
)
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "QNX")
  target_link_libraries(common_http PUBLIC socket)
endif()

add_library(common_log STATIC)
# Accept the global compiler flags
target_compile_options(common_log PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
target_sources(common_log PRIVATE log/platform/boost/boost_log.cpp)
target_link_libraries(common_log PUBLIC common_error Boost::log)

add_library(common_processes STATIC processes/processes.cpp)
target_compile_options(common_processes PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
target_link_libraries(common_processes PUBLIC common_error common_events common_log common)
if(MENDER_USE_TINY_PROC_LIB)
  target_sources(common_processes PRIVATE processes/platform/tiny_process_library/tiny_process_library.cpp)
  target_include_directories(common_processes PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/vendor/tiny-process-library)
  target_link_libraries(common_processes PUBLIC tiny-process-library::tiny-process-library common_path)
endif()

add_library(common_key_value_parser STATIC key_value_parser/key_value_parser.cpp)
target_link_libraries(common_key_value_parser PUBLIC common_error)

add_library(common_crypto STATIC crypto/crypto.cpp crypto/platform/openssl/crypto.cpp)
target_compile_options(common_crypto PRIVATE
  ${PLATFORM_SPECIFIC_COMPILE_OPTIONS}
  # For OpenSSLv3 we do want the deprecated support to support the Engine API
  -Wno-deprecated-declarations
)
target_link_libraries(common_crypto PUBLIC
  common_log
  common_io
  common_path
  sha
  OpenSSL::SSL
  OpenSSL::Crypto
)

if(MENDER_USE_DBUS)
  find_package(PkgConfig REQUIRED)
  pkg_check_modules(dbus REQUIRED dbus-1)
  add_library(common_dbus STATIC platform/dbus/dbus.cpp platform/dbus/asio_libdbus/dbus.cpp)
  target_link_libraries(common_dbus PUBLIC
    common_log
    common_error
    common_events
    ${dbus_LDFLAGS}
  )
  target_compile_options(common_dbus PUBLIC ${dbus_CFLAGS})

  if(MENDER_USE_ASIO_LIBDBUS)
    target_sources(common_dbus PRIVATE platform/dbus/asio_libdbus/dbus.cpp)
    target_link_libraries(common_dbus PUBLIC
      OpenSSL::SSL
      OpenSSL::Crypto
    )
  endif()
endif()

# Header-only.
add_library(common_state_machine INTERFACE)

if (MENDER_USE_YAML_CPP)
  add_subdirectory(vendor/yaml-cpp)
  add_library(common_yaml STATIC yaml/yaml.cpp yaml/platform/yaml-cpp/yaml.cpp)
  target_link_libraries(common_yaml PUBLIC common common_io common_error yaml-cpp::yaml-cpp)
  target_compile_options(common_yaml PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
endif()

add_library(mender_http_resumer STATIC
  http/http_resumer.cpp
)
target_link_libraries(mender_http_resumer PUBLIC
  common_http
)

=== src/mender-auth/CMakeLists.txt ===
add_subdirectory(api)
add_subdirectory(cli)
add_subdirectory(http_forwarder)

if(MENDER_USE_DBUS)
  add_subdirectory(ipc)
endif()

if(NOT MENDER_EMBED_MENDER_AUTH)
  add_executable(mender-auth main.cpp)
  target_link_libraries(mender-auth PRIVATE
    mender_auth_cli
  )
  install(TARGETS mender-auth
    DESTINATION bin
    COMPONENT mender-auth
  )
  add_custom_target(install-mender-auth
    COMMAND ${CMAKE_COMMAND} --install . --component mender-auth
  )
  add_custom_target(uninstall-mender-auth
    COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component mender-auth -P ${MENDER_BINARY_SRC_DIR}/cmake_uninstall.cmake
    WORKING_DIRECTORY ${MENDER_BINARY_SRC_DIR}
  )
endif()

=== src/mender-update/CMakeLists.txt ===
add_library(mender_context STATIC context/context.cpp)
target_link_libraries(mender_context PUBLIC
  artifact
  common_error
  common_key_value_database
  client_shared_conf
  common_json
  common_log
  common_path
)

add_library(mender_deployments STATIC deployments/deployments.cpp)
target_link_libraries(mender_deployments PUBLIC
  api_client
  mender_context
  common_error
  common_events
  common_http
  common_io
  common_json
  common_log
  common_path
)
target_sources(mender_deployments PRIVATE deployments/platform/boost_log/deployments.cpp)
target_compile_options(mender_deployments PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})

add_library(mender_inventory STATIC inventory.cpp)
target_link_libraries(mender_inventory PUBLIC
  api_client
  common_error
  common_events
  common_http
  common_io
  client_shared_inventory_parser
  common_json
  common_path
)

add_library(update_module STATIC
  update_module/v3/update_module.cpp
  update_module/v3/update_module_download.cpp
)
target_link_libraries(update_module PUBLIC
  common
  common_log
  client_shared_conf
  common_processes
  mender_context
  artifact
  mender_progress_reader
)
target_sources(update_module PRIVATE
  update_module/v3/platform/c++17/fs_operations.cpp
  update_module/v3/platform/c++17/update_module_call.cpp
)
target_compile_options(update_module PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})

add_library(mender_update_standalone STATIC
  standalone/context.cpp
  standalone/standalone.cpp
  standalone/states.cpp
)
target_link_libraries(mender_update_standalone PUBLIC
  common_error
  common_http
  update_module
  mender_context
  artifact_scripts_executor
)

add_library(mender_update_daemon STATIC
  daemon/context.cpp
  daemon/states.cpp
  daemon/state_machine/state_machine.cpp
  daemon/state_machine/platform/posix/signal_handling.cpp
)
target_link_libraries(mender_update_daemon PUBLIC
  api_client
  common_error
  common_http
  mender_http_resumer
  update_module
  mender_context
  mender_deployments
  mender_inventory
  artifact_scripts_executor
  common_state_machine
)
if(MENDER_EMBED_MENDER_AUTH)
  target_link_libraries(mender_update_daemon PUBLIC
    mender_auth_api_auth
    mender_auth_cli
  )
endif()

add_library(mender_update_cli STATIC
  cli/actions.cpp
  cli/cli.cpp
)
target_link_libraries(mender_update_cli PUBLIC
  common_error
  mender_context
  mender_update_daemon
  mender_update_standalone
)

add_executable(mender-update main.cpp)
target_link_libraries(mender-update PRIVATE
  common_log
  client_shared_conf
  mender_context
  update_module
  common_setup
  mender_update_cli
)
install(TARGETS mender-update
  DESTINATION bin
  COMPONENT mender-update
)

add_custom_target(install-mender-update
  COMMAND ${CMAKE_COMMAND} --install . --component mender-update
)
add_custom_target(uninstall-mender-update
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_component mender-update -P ${MENDER_BINARY_SRC_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${MENDER_BINARY_SRC_DIR}
)

add_subdirectory(progress_reader)

=== src/artifact/sha/CMakeLists.txt ===

find_package(OpenSSL REQUIRED)
if(NOT ${OpenSSL_Found})
  message(FATAL_ERROR "OpenSSL not found during build")
endif()

add_library(sha STATIC sha.cpp platform/openssl/sha.cpp)
target_link_libraries(sha PUBLIC OpenSSL::SSL OpenSSL::Crypto)
target_link_libraries(sha PUBLIC common_log common_error common_io)
target_compile_options(sha PRIVATE ${PLATFORM_SPECIFIC_COMPILE_OPTIONS})
target_include_directories(sha PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

=== debian/changelog ===
mender-client (5.0.0-1) experimental; urgency=medium

  * New upstream release
    - rewritten from scratch in C++, previously Go
    - debian packaging also redone from scratch.

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 05 Jan 2025 21:11:53 +0100

=== debian/control ===
Source: mender-client
Section: utils
Priority: optional
Maintainer: Andreas Henriksson <andreas@fatal.se>
Uploaders: Lluis Campos <lluis.campos@northern.tech>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libarchive-dev,
 liblmdb-dev,
 libboost-all-dev,
 libssl-dev,
 libdbus-1-dev,
 libsystemd-dev,
 nlohmann-json3-dev,
 libgtest-dev <!nocheck>,
 libgmock-dev <!nocheck>,
Standards-Version: 4.7.0
Homepage: https://github.com/mendersoftware/mender
Vcs-Browser: https://salsa.debian.org/go-team/packages/mender-client
Vcs-Git: https://salsa.debian.org/go-team/packages/mender-client.git

Package: mender-client
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: over-the-air updater for embedded Linux devices
 Mender is an open source over-the-air (OTA) software updater for embedded
 Linux devices. Mender comprises a client running at the embedded device, as
 well as a server that manages deployments across many devices.
 .
 Embedded product teams often end up creating homegrown updaters
 at the last minute due to the need to fix bugs in field-deployed
 devices. However, the most important requirement for an embedded update
 process is robustness, for example loss of power at any time should not
 brick a device. This creates a challenge given the time constraints to
 develop and maintain a homegrown updater.
 .
 Mender aims to address this challenge with a robust and easy to use
 updater for embedded Linux devices, which is open source and available
 to anyone.
 .
 Robustness is ensured with atomic image-based deployments using a dual
 A/B rootfs partition layout. This makes it always possible to roll
 back to a working state, even when losing power at any time during the
 update process.
 .
 Ease of use is addressed with an intuitive UI, comprehensive documentation
 (https://docs.mender.io/), a meta layer for the Yocto Project
 (https://github.com/mendersoftware/meta-mender) for easy integration
 into existing environments, and high quality software (see the test
 coverage badge).
 .
 This repository contains the Mender client updater, which can be run in
 standalone mode (manually triggered through its command line interface)
 or managed mode (connected to the Mender server).
 .
 Mender not only provides the client-side updater, but also the backend and
 UI for managing deployments as open source. The Mender server is designed
 as a microservices architecture and comprises several repositories.
 .
 To start using Mender, we recommend that you begin with the Getting
 started section in the Mender documentation (https://docs.mender.io/).
 .
 In order to support rollback, the Mender client depends on integration
 with U-Boot and the partition layout. It is therefore most easily
 built as part of your Yocto Project image by using the meta layer for
 the Yocto Project (https://github.com/mendersoftware/meta-mender).

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DSYSTEMD_UNIT_DIR=/usr/lib/systemd/system

override_dh_auto_test:
	dh_auto_test || true

get-orig-source:
	gbp export-orig --submodules
	gunzip ../mender-client_$(DEB_VERSION_UPSTREAM).orig.tar.gz
	# exclude vendored json, we use nlohmann-json3-dev
	# exclude vendored yaml-cpp, unused.
	tar --delete -f ../mender-client_$(DEB_VERSION_UPSTREAM).orig.tar \
		mender-client-$(DEB_VERSION_UPSTREAM)/src/common/vendor/json \
		mender-client-$(DEB_VERSION_UPSTREAM)/src/common/vendor/yaml-cpp \
		$(NULL)
	gzip ../mender-client_$(DEB_VERSION_UPSTREAM).orig.tar

=== debian/watch ===
version=4
https://github.com/mendersoftware/mender/tags .*/v?(\d.*)@ARCHIVE_EXT@
